int		LeftClip	= 0;
int		RightClip	= 799;
int		UpperClip	= 0;
int		LowerClip	= 599;
int		FarClip		= 9000;
int		NearClip	= -300;



void ClipObject(D3Object_ptr Object);
bool ClipFace(grVertex_ptr a,grVertex_ptr b,grVertex_ptr c);
bool SimpleClip(grVertex_ptr Vertex0,grVertex_ptr Vertex1,
				grVertex_ptr Vertex2,grVertex_ptr Vertex3, float DivDist);
bool  Clip(grVertex_ptr Vertex0, grVertex_ptr Vertex1,
	     	  grVertex_ptr Vertex2, float DivDist);



void ClipObject(D3Object_ptr Object)
{	if (Object->World_Pos.z>FarClip || Object->World_Pos.z< (NearClip-200) ) Object->Clip = true;
	else Object->Clip = false;

	for (int count=0;count<Object->NumFaces;count++)
	{	if ( Object->Vertices_world[Object->Faces[count].a].z<0 &&
			 Object->Vertices_world[Object->Faces[count].b].z<0 &&
			 Object->Vertices_world[Object->Faces[count].c].z<0 )
			Object->Faces[count].Clip = false;
		else
			Object->Faces[count].Clip = true;
	}

}

bool ClipFace(grVertex_ptr a,grVertex_ptr b,grVertex_ptr c)
{	if ( (a->x<LeftClip		&& b->x<LeftClip	&& c->x<LeftClip)	||
		 (a->y<UpperClip	&& b->y<UpperClip	&& c->y<UpperClip)	||
		 (a->x>RightClip	&& b->x>RightClip	&& c->x>RightClip)	||
		 (a->y>LowerClip	&& b->y>LowerClip	&& c->y>LowerClip)	 )
		return false;
	else return true;
}


bool SimpleClip(grVertex_ptr Vertex0,grVertex_ptr Vertex1,
				grVertex_ptr Vertex2,grVertex_ptr Vertex3, float DivDist)
{	
	float	breedte = (255.0/(float)(Vertex1->x - Vertex0->x))*DivDist; 
	float	height	= (255.0/(float)(Vertex2->y - Vertex0->y))*DivDist;
	float	OutSideClip;

	if	(( Vertex1->x<0   ) ||
		 ( Vertex0->x>799 ) ||
		 ( Vertex2->y<0	  ) ||
		 ( Vertex0->y>599 )	)
		return false;

	if ( Vertex0->x < 0 )
	{	OutSideClip	= -Vertex0->x;
		Vertex0->x	= 0;
		Vertex0->u	= OutSideClip*breedte; 
		Vertex2->x	= 0;
		Vertex2->u	= Vertex0->u;
	}
	if ( Vertex0->y < 0 )
	{	OutSideClip	= -Vertex0->y;
		Vertex0->y	= 0;
		Vertex0->v	= OutSideClip*height;
		Vertex1->y	= 0;
		Vertex1->v	= Vertex0->v;
	}
	
	if ( Vertex1->x > 799 )
	{	OutSideClip = 799-Vertex0->x;
		Vertex1->x	= 799;
		Vertex1->u	= OutSideClip*breedte;
		Vertex3->x	= 799;
		Vertex3->u	= Vertex1->u;
	}
	if ( Vertex2->y > 599 )
	{	OutSideClip = 599-Vertex0->y;
		Vertex2->y	= 599;
		Vertex2->v	= OutSideClip*height;
		Vertex3->y	= 599;
		Vertex3->v	= Vertex2->v;
	}
	return true;
}


/////////////// Testen ! //////////////////
bool  Clip(grVertex_ptr Vertex0, grVertex_ptr Vertex1,
	     	  grVertex_ptr Vertex2, float DivDist)
{	
	grVertex polygon[6];
	int n=0;

	bool outplane[3];
	int newx[6];
	int newy[6];



	grVertex V[2];

	newx[0] = Vertex0->x;newy[0] = Vertex0->y;
    newx[1] = Vertex1->x;newy[1] = Vertex1->y;

	for (int i=0; i<3; outplane[i++] = false);
	if (Vertex0->x < 100 || Vertex0->y < 100) outplane[0] = true;
	if (Vertex1->x < 100 || Vertex1->y < 100) outplane[1] = true;
	if (Vertex2->x < 100 || Vertex2->y < 100) outplane[2] = true;

	if (Vertex0->x > 699 || Vertex0->y > 499) outplane[0] = true;
	if (Vertex1->x > 699 || Vertex1->y > 499) outplane[1] = true;
	if (Vertex2->x > 699 || Vertex2->y > 499) outplane[2] = true;

	if (! (Vertex0->x && Vertex0->y) ) 
	{	polygon[n  ].x = Vertex0->x;
		polygon[n++].y = Vertex0->y;
	}

	if (! (Vertex1->x && Vertex1->y) ) 
	{	polygon[n  ].x = Vertex1->x;
		polygon[n++].y = Vertex1->y;
	}

	if (! (Vertex2->x && Vertex2->y) ) 
	{	polygon[n  ].x = Vertex2->x;
		polygon[n++].y = Vertex2->y;
	}


	//if (! (outplane[0] || outplane[1]));
	if (! outplane[0] && outplane[1]) {

		if (Vertex1->y < 100) {
			newx[1] = Vertex0->x + ((100 - Vertex0->y) * (Vertex1->x - Vertex0->x)) / (Vertex1->y - Vertex0->y);
			newy[1] = 100;
		}

		if (Vertex1->x > 699) {
			newy[1] = Vertex0->y + ((699 - Vertex0->x) * (Vertex1->y - Vertex0->y)) / (Vertex1->x - Vertex0->x);
			newx[1] = 699;
		}

		if (Vertex1->y > 499) {
			newx[1] = Vertex0->x + ((499 - Vertex0->y) * (Vertex1->x - Vertex0->x)) / (Vertex1->y - Vertex0->y);
			newy[1] = 499;
		}

		if (Vertex1->x < 100) {
			newy[1] = Vertex0->y + ((100 - Vertex0->x) * (Vertex1->y - Vertex0->y)) / (Vertex1->x - Vertex0->x);
			newx[1] = 100;
		}
	}


		if (! outplane[1] && outplane[0]) {

		if (Vertex0->y < 100) {
			newx[1] = Vertex1->x + ((100 - Vertex1->y) * (Vertex1->x - Vertex0->x)) / (Vertex1->y - Vertex0->y);
			newy[1] = 100;
		}

		if (Vertex0->x > 699) {
			newy[1] = Vertex1->y + ((699 - Vertex1->x) * (Vertex1->y - Vertex0->y)) / (Vertex1->x - Vertex0->x);
			newx[1] = 699;
		}

		if (Vertex0->y > 499) {
			newx[1] = Vertex1->x + ((499 - Vertex1->y) * (Vertex1->x - Vertex0->x)) / (Vertex1->y - Vertex0->y);
			newy[1] = 499;
		}

		if (Vertex0->x < 100) {
			newy[1] = Vertex1->y + ((100 - Vertex1->x) * (Vertex1->y - Vertex0->y)) / (Vertex1->x - Vertex0->x);
			newx[1] = 100;
		}
	}


	V[0].x = newx[0]; V[0].y = newy[0]; V[0].z = 1/2; V[0].g = 255;
	V[1].x = newx[1]; V[1].y = newy[1]; V[0].z = 1/2; V[1].r = 255;

	grDrawLine(&V[0], &V[1]);
	
	
	return(0);

	
}