#include <time.h>

typedef struct Particle_type 
{	char	State;
	float	Speed;
	float	Energy;
	float	Acc;
	float	Color;
	float	Scale;
	Normal	Direction;
	Normal	Position;
	Normal	PositionRot;
	Normal	Screen;
} Particle, *Particle_ptr;

typedef struct PartSystem_type 
{	float x,y,z;
	float xr,yr,zr;
	Particle Part[100];
} PartSystem, *PartSystem_ptr;



void RenderLensFlare(TextureMap *tex1,
					 TextureMap *tex2,
					 TextureMap *tex3,
					 TextureMap *tex4,
					 int lx,int ly, float Dist, int cx, int cy);

void Render(int x, int y, int r, int g, int b, int Size, float Dist);
void RotatePartSystem(PartSystem_ptr System, int nr, int angleX, int angleY, int angleZ, int xm, int ym);






void RenderLensFlare(TextureMap *tex1,
					 TextureMap *tex2,
					 TextureMap *tex3,
					 TextureMap *tex4,
					 int lx,int ly, float Dist, int cx, int cy)
{	
	grVertex FlareFace[4];
	int vx = cx - lx;
	int vy = cy - ly;
	int NewX,NewY;


	grDepthBufferFunction(GR_CMP_ALWAYS);

	grColorCombine(	GR_COMBINE_FUNCTION_SCALE_OTHER,GR_COMBINE_FACTOR_LOCAL,
					GR_COMBINE_LOCAL_CONSTANT,GR_COMBINE_OTHER_TEXTURE,FXFALSE);
	
	grAlphaBlendFunction(GR_BLEND_ONE,GR_BLEND_ONE,GR_BLEND_ONE,GR_BLEND_ZERO);


	grTexSource(GR_TMU0,tex1->VideoMemoryAddressTMU0,
						GR_MIPMAPLEVELMASK_BOTH,
						&tex1->TexInfo);
	Render(lx,ly,255,255,255,80, Dist);

	NewX =  lx + 0.5 * vx;
	NewY =  ly + 0.5 * vy;
	
	grTexSource(GR_TMU0,tex2->VideoMemoryAddressTMU0,
						GR_MIPMAPLEVELMASK_BOTH,
						&tex2->TexInfo);
	Render(NewX,NewY,255,255,255,48, Dist);

	NewX =  lx + 0.55 * vx;
	NewY =  ly + 0.55 * vy;
	
	grTexSource(GR_TMU0,tex1->VideoMemoryAddressTMU0,
						GR_MIPMAPLEVELMASK_BOTH,
						&tex1->TexInfo);
	Render(NewX,NewY,255,255,255,48, Dist);

	NewX =  lx + 0.6 * vx;
	NewY =  ly + 0.6 * vy;
	
	grTexSource(GR_TMU0,tex3->VideoMemoryAddressTMU0,
						GR_MIPMAPLEVELMASK_BOTH,
						&tex3->TexInfo);
	Render(NewX,NewY,255,255,255,16, Dist);

	NewX =  lx + 1.9 * vx;
	NewY =  ly + 1.9 * vy;
	
	grTexSource(GR_TMU0,tex4->VideoMemoryAddressTMU0,
						GR_MIPMAPLEVELMASK_BOTH,
						&tex4->TexInfo);
	Render(NewX,NewY,255,255,255,80, Dist);

	
	NewX =  lx + 1.7 * vx;
	NewY =  ly + 1.7 * vy;
	
	grTexSource(GR_TMU0,tex1->VideoMemoryAddressTMU0,
						GR_MIPMAPLEVELMASK_BOTH,
						&tex1->TexInfo);
	Render(NewX,NewY,255,255,255,32, Dist);

	NewX =  lx + 1.75 * vx;
	NewY =  ly + 1.75 * vy;

	grTexSource(GR_TMU0,tex2->VideoMemoryAddressTMU0,
						GR_MIPMAPLEVELMASK_BOTH,
						&tex2->TexInfo);
	Render(NewX,NewY,255,255,255,48, Dist);

	NewX =  lx - 0.15 * vx;
	NewY =  ly - 0.15 * vy;
	
	grTexSource(GR_TMU0,tex4->VideoMemoryAddressTMU0,
						GR_MIPMAPLEVELMASK_BOTH,
						&tex4->TexInfo);
	Render(NewX,NewY,255,255,255,64, Dist);


	grDepthBufferFunction(GR_CMP_GREATER);

	grColorCombine(	GR_COMBINE_FUNCTION_LOCAL, 
					GR_COMBINE_FACTOR_NONE,
					GR_COMBINE_LOCAL_ITERATED, 
					GR_COMBINE_OTHER_NONE, FXFALSE);

	grAlphaBlendFunction(GR_BLEND_ONE,GR_BLEND_ZERO,GR_BLEND_ONE,GR_BLEND_ZERO);
}

void Render(int x, int y, int r, int g, int b, int Size, float Dist)
{	grVertex FlareFace[4];

	int UpperX = x-Size;
	int UpperY = y-Size;
	int LowerX = x+Size;
	int LowerY = y+Size;
	float DivDist = 1.0/Dist;
	
	grConstantColorValue(((unsigned short)r)<<24 | ((unsigned short)g)<<16 | ((unsigned short)b)<<8);

	FlareFace[0].x = UpperX;
	FlareFace[0].y = UpperY;
	FlareFace[0].z = DivDist;
	FlareFace[0].u = 0;
	FlareFace[0].v = 0;

	FlareFace[1].x = LowerX;
	FlareFace[1].y = UpperY;
	FlareFace[1].z = DivDist;
	FlareFace[1].u = 255.0*DivDist;
	FlareFace[1].v = 0;

	FlareFace[2].x = UpperX;
	FlareFace[2].y = LowerY;
	FlareFace[2].z = DivDist;
	FlareFace[2].u = 0;
	FlareFace[2].v = 255.0*DivDist;

	FlareFace[3].x = LowerX;
	FlareFace[3].y = LowerY;
	FlareFace[3].z = DivDist;
	FlareFace[3].u = 255.0*DivDist;
	FlareFace[3].v = 255.0*DivDist;
	
	if (SimpleClip(&FlareFace[0],&FlareFace[1],&FlareFace[2],&FlareFace[3], DivDist) == true)
	{
		grDrawTriangle(&FlareFace[0],&FlareFace[1],&FlareFace[3]);
		grDrawTriangle(&FlareFace[0],&FlareFace[2],&FlareFace[3]);
	}
}

void SetupParticleSystem(PartSystem_ptr System)
{	int count;

	
	srand( (unsigned)time( NULL ));


	for (count=0;count<=100;count++)
	{	System->Part[count].State  = 1;
		System->Part[count].Energy = 1;

		System->Part[count].Color = 255;

		System->Part[count].Direction.x = (float) (((float)(rand() % 255)/800)-0.16);
		System->Part[count].Direction.y = (float)(-((float)(rand() % 255)/255));

		System->Part[count].Speed = (float) (rand())/1000;

		System->Part[count].Acc = 0.002;
	}
}

void PositionParticleSystem(PartSystem_ptr System, int x, int y, int z)
{	System->x = x;
	System->y = y;
	System->z = z;
}

void TranslateParticleSystem(PartSystem_ptr System, int xtrans, int ytrans, int ztrans)
{	System->x += xtrans;
	System->y += ytrans;
	System->z += ztrans;
}

void RenderParticleSystem(PartSystem_ptr System, TextureMap *tex1, int arc1, int arc2, int arc3)
{	int count;
	float Color, Depth;
	
	grDepthBufferFunction(GR_CMP_ALWAYS);

	grColorCombine(	GR_COMBINE_FUNCTION_SCALE_OTHER,GR_COMBINE_FACTOR_LOCAL,
					GR_COMBINE_LOCAL_CONSTANT,GR_COMBINE_OTHER_TEXTURE,FXFALSE);
	
	grAlphaBlendFunction(GR_BLEND_ONE,GR_BLEND_ONE,GR_BLEND_ONE,GR_BLEND_ZERO);
			

	grTexSource(GR_TMU0,tex1->VideoMemoryAddressTMU0,
						GR_MIPMAPLEVELMASK_BOTH,
						&tex1->TexInfo);

	for (count=0;count<=100;count++)
	{	if (System->Part[count].State == 1 && System->Part[count].Color>1)
		{	
			System->Part[count].Position.x  += ( System->Part[count].Direction.x*System->Part[count].Speed );
			System->Part[count].Position.y  += ( System->Part[count].Direction.y*System->Part[count].Speed );
		
			
			System->Part[count].Speed *= 0.93;
	
			if (System->Part[count].Color>0.5) System->Part[count].Color *= 0.93;
	
			if (System->Part[count].Speed<0.7)
			{	
				System->Part[count].Position.x = 0;
				System->Part[count].Position.y = 0;
				System->Part[count].State  = 1;
				System->Part[count].Energy = 1;
				System->Part[count].Color = 255;
		
				System->Part[count].Direction.x = (float) (((float)(rand() % 255)/800)-0.16);
				System->Part[count].Direction.y = (float)(-((float)(rand() % 255)/255));
	
				System->Part[count].Speed = (float) (rand())/1000;
				System->Part[count].Acc = 0.002;
			}

			RotatePartSystem(System,count,arc1,arc2,arc3, 400, 300);
			Render(	System->Part[count].Screen.x,
					System->Part[count].Screen.y,
					System->Part[count].Color,
					System->Part[count].Color,
					80,
					48*System->Part[count].Scale, 
					System->Part[count].Screen.z);
		}
	}

	grDepthBufferFunction(GR_CMP_GREATER);

	grColorCombine(	GR_COMBINE_FUNCTION_LOCAL, 
					GR_COMBINE_FACTOR_NONE,
					GR_COMBINE_LOCAL_ITERATED, 
					GR_COMBINE_OTHER_NONE, FXFALSE);

	grAlphaBlendFunction(GR_BLEND_ONE,GR_BLEND_ZERO,GR_BLEND_ONE,GR_BLEND_ZERO);
}			


void RotatePartSystem(PartSystem_ptr System, int nr, int angleX, int angleY, int angleZ, int xm, int ym)
{	float temp_x,temp_y,temp_z, scale, dist = 500;
	float PosX, PosY, PosZ;

	PosX = System->xr = System->Part[nr].Position.x + System->x;
	PosY = System->yr = System->Part[nr].Position.y + System->y;
	PosZ = System->zr = System->Part[nr].Position.z + System->z;

	temp_x	= c[angleX] * PosX - s[angleX] * PosY;
	temp_y	= s[angleX] * PosX + c[angleX] * PosY;
		
	System->Part[nr].PositionRot.x = c[angleY] * temp_x - s[angleY] * PosZ;
	temp_z						   = s[angleY] * temp_x + c[angleY] * PosZ;

	System->Part[nr].PositionRot.y = c[angleZ] * temp_y - s[angleZ] * temp_z;
	System->Part[nr].PositionRot.z = c[angleZ] * temp_z + s[angleZ] * temp_y;

	System->Part[nr].Scale = dist/((float)System->Part[nr].PositionRot.z+dist);
	System->Part[nr].Screen.x = xm + System->Part[nr].PositionRot.x * System->Part[nr].Scale ;
	System->Part[nr].Screen.y = ym + System->Part[nr].PositionRot.y * System->Part[nr].Scale ;
	System->Part[nr].Screen.z = dist - System->Part[nr].PositionRot.z;
}




